package com.logicbig.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.SqlOutParameter;
import org.springframework.jdbc.core.SqlParameter;
import org.springframework.jdbc.core.namedparam.MapSqlParameterSource;
import org.springframework.jdbc.core.simple.SimpleJdbcCall;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import javax.sql.DataSource;
import java.sql.Types;
import java.util.Map;

@Component
public class ClientBean {
    @Autowired
    private DataSource dataSource;
    private SimpleJdbcCall jdbcCall;

    @PostConstruct
    public void init() {
        JdbcTemplate template = new JdbcTemplate(dataSource);
        jdbcCall = new SimpleJdbcCall(template)
                .withProcedureName("GET_SUM")
                .declareParameters(
                        new SqlParameter("a", Types.INTEGER),
                        new SqlParameter("b", Types.INTEGER),
                        new SqlOutParameter("theSum", Types.INTEGER));

    }

    public void findSum() {
        MapSqlParameterSource paramMap = new MapSqlParameterSource()
                .addValue("a", 5)
                .addValue("b", 20);
        Map<String, Object> resultMap = jdbcCall.execute(paramMap);
        resultMap.entrySet().forEach(System.out::println);
    }
}